#include "CurveUtilities.h"

#include "Point.h"

#ifdef WIN32
namespace CurveUtilities
{
#endif

	double binomialCoefficient(const unsigned int & n, const unsigned int & k)
	{
		unsigned int top = factorial(n);
		
		unsigned int bottom = factorial(k) * factorial(n - k);

		double result = (static_cast<double>(top) / static_cast<double>(bottom));

		return result;
	}

	unsigned int factorial(const unsigned int & x)
	{
		unsigned int result = 1;
		
		if (x == 0)
		{
			result = 1;
		}
		else
		{
			result *= (x * factorial(x - 1));
		}

		return result;
	}

	double raiseToIntegerPower(const double & x, const unsigned int & y)
	{
		double result = 1;

		for (unsigned int power_index = 0; power_index < y; power_index++)
		{
			result *= x;
		}

		return result;
	}

	Point linearlyInterpolate(const Point & first_point, const Point & second_point, double t)
	{
		double interpolated_x = (t) * first_point.x + (1 - t) * second_point.x;
		double interpolated_y = (t) * first_point.y + (1 - t) * second_point.y;
		
		Point result(interpolated_x, interpolated_y);

		return result;
	}
#ifdef WIN32
}
#endif