#ifndef INCLUDED_ZOOM_DIMENSIONS_H
#define INCLUDED_ZOOM_DIMENSIONS_H

class ZoomDimensions
{
	public:

		ZoomDimensions(void);

		ZoomDimensions(const double & left, const double & right, const double & bottom, const double & top);

		void setLeftBottom(const double & left, const double & bottom);

		void setRightTop(const double & right, const double & top);

		void swapIfOutOfOrder(void);

		double getLeft(void) const;
		double getRight(void) const;
		double getBottom(void) const;
		double getTop(void) const;

		double getHorizontalRange(void) const;
		double getVerticalRange(void) const;

	private:

		double m_left;
		double m_right;
		double m_bottom;
		double m_top;
};

#endif